<?php

$mod_defTables = array(
	'user' => array(
		'username' => array('text' => 0, 'index' => array('username' => 16, 'password' => 32)),
		'password' => array('char' => 32),
		'email' => array('text' => 0),
		'rights' => array('int' => 11),
		'deleted' => array('int' => 11, 'default' => 0),
		'data' => array('longtext' => 0),
		'active' => array('int' => 11, 'default' => 1)
	),
	'menu' => array(
		'name' => array('text' => 0),
		'url' => array('text' => 0),
		'urlopt' => array('text' => 0),
		'root' => array('int' => 11, 'index' => array('root' => 0, 'sort' => 0)),
		'sort' => array('int' => 11),
		'misc' => array('int' => 11),
		'java' => array('tinyint' => 4)
	),
	'menulang' => array(
		'menu_id' => array('int' => 11, 'index' => 0),
		'language' => array('char' => 2, 'index' => 2),
		'name' => array('text' => 0)
	),
	'groups' => array(
		'name' => array('text' => 0),
		'deleted' => array('int' => 11, 'default' => 0),
		'rights' => array('int' => 11, 'default' => 0)
	),
	'grouplink' => array(
		'source' => array('int' => 11, 'index' => 0),
		'group_id' => array('int' => 11, 'index' => 0),
		'type' => array('enum' => '"group","user"')
	),
	'session' => array(
		'user_id' => array('int' => 11),
		'timestamp' => array('int' => 11, 'index' => 0),
		'md5' => array('char' => 32, 'index' => array('md5' => 32, 'ip' => 0)),
		'ip' => array('int' => 11, 'attribute' => 'unsigned'),
		'data' => array('longtext' => 0),
		'alias' => array('int' => 11, 'default' => 0)
	),
	'rights' => array(
		'name' => array('text' => 0),
		'right_id' => array('int' => 11)
	),
	'log' => array(
		'file' => array('text' => 0, 'index' => 8),
		'user_id' => array('int' => 11, 'index' => 0),
		'ip' => array('int' => 11, 'index' => 0, 'attribute' => 'unsigned'),
		'time' => array('int' => 11, 'index' => 0),
		'session_id' => array('int' => 11, 'index' => 0),
		'param' => array('int' => 11, 'index' => 0, 'default' => 0)
	),
	'logparam' => array(
		'log_id' => array('int' => 11, 'index' => 0),
		'name' => array('text' => 0),
		'value' => array('longtext' => 0)
	),
	'globals' => array(
		'name' => array('text' => 0),
		'value' => array('longtext' => 0),
		'ref' => array('int' => 11, 'index' => array('ref' => 0, 'type' => 8), 'default' => 0),
		'type' => array('char' => 8, 'default' => ''),
		'array' => array('tinyint' => 4, 'default' => 0)
	),
	'validate' => array(
		'user_id' => array('int' => 11, 'index' => 0),
		'hash' => array('char' => 32),
		'type' => array('tinyint' => 4),
		'timestamp' => array('int' => 11)
	),
	'action' => array(
		'user_id' => array('int' => 11, 'default' => 0),
		'type' => array('text' => 0, 'index' => 16),
		'ip' => array('int' => 11, 'attribute' => 'unsigned', 'index' => array('ip' => 0, 'data' => 16, 'type' => 16)),
		'timestamp' => array('int' => 11),
		'data' => array('text' => 0)
	),
	'changes' => array(
		'table' => array('text' => 0, 'index' => array('table' => 16, 'entry_id' => 0)),
		'entry_id' => array('int' => 11),
		'text' => array('text' => 0),
		'timestamp' => array('int' => 11),
		'user_id' => array('int' => 11)
	),
	'item_groups' => array(
		'user_id' => array('int' => 11, 'index' => 0),
		'timestamp' => array('int' => 11),
		'shipping_type_id' => array('int' => 11, 'default' => 0),
		'ordered' => array('int' => 11, 'default' => 0),
		'ordered_at' => array('int' => 11, 'default' => 0),
		'adress_id' => array('int' => 11, 'default' => 0),
		'delivery_adress' => array('int' => 11, 'default' => 0)
	),
	'item_lists' => array(
		'group_id' => array('int' => 11, 'index' => 0),
		'item_id' => array('int' => 11, 'index' => array('item_id' => 0, 'group_id' => 0)),
		'amount' => array('int' => 11),
		'price' => array('double' => 0, 'null' => true)
	),
	'shop_shipping' => array(
		'name' => array('text' => 0),
		'price' => array('double' => 0),
		'free' => array('double' => 0)
	),
	'category_link' => array(
		'category_id' => array('int' => 11, 'index' => 0),
		'article_id' => array('int' => 11, 'index' => 0),
		'sort' => array('int' => 11)
	),
	'articles' => array(
	),
	'article_links' => array(
	),
	'article_prices' => array(
	),
	'shop_adress' => array(
		'company' => array('text' => 0),
		'forename' => array('text' => 0),
		'surname' => array('text' => 0),
		'street' => array('text' => 0),
		'zip' => array('int' => 11),
		'city' => array('text' => 0),
		'contact_id' => array('int' => 11, 'default' => 0),
		'user_id' => array('int' => 11, 'index' => 0)
	),
	'shop_contact' => array(
		'tel' => array('text' => 0),
		'fax' => array('text' => 0),
		'email' => array('text' => 0)
	)
);

function checkDB($db, $sql = false)
{
	global $modules_defaults;
	if ($sql === false) $sql = $modules_defaults['sql'];

	if ($db == '') trigger_error('No Database given', E_USER_ERROR);

	$db = mysql_escape_string($db);
	$query = "CREATE DATABASE IF NOT EXISTS `$db`";
	mod_mysql_querya($query, $sql);

}

function mod_checkTableReplace($string)
{
	return(str_replace(array('varchar', '"'), array('char', '\''), strtolower($string)));
}

function checkTable($table, $tablename, $sql = false)
{
	global $modules_defaults, $mod_defTables;
	if (isset($modules_defaults['checkdb']) && !$modules_defaults['checkdb']) return;
	if ($sql === false) $sql = $modules_defaults['sql'];

	if (is_string($table))
	{
		$table = $mod_defTables[$table];
	}

	if ($tablename == '') trigger_error('Invalid Table Name', E_USER_ERROR);

	$esTable = mysql_escape_string($tablename);
	$query = "CREATE TABLE IF NOT EXISTS `$esTable` (`id` INT NOT NULL AUTO_INCREMENT, PRIMARY KEY (`id`));";
	mod_mysql_querya($query, $sql);

	foreach ($table AS $index => &$field)
	{
		$keys = array_keys($field);
		$type = reset($keys);
		$size = reset($field);
		if ($size != '') $type .= "($size)";
		if (array_key_exists('index', $field))
		{
			if (!is_array($field['index']))
			{
				$indexes = array($index => $field['index']);
			}
			else
			{
				$indexes = $field['index'];
			}
			foreach($indexes as $a => &$b)
			{
				$b = '`' . mysql_escape_string($a) . '`' . ($b == '' || $b == 0 ? '' : "($b)");
			}
		}
		else
		{
			$indexes = array();
		}
		if (array_key_exists('attribute', $field)) $type .= ' ' . $field['attribute'];
		$field['type'] = $type;
		$field['index'] = $indexes;
	}
	unset($field);

	$query = "DESCRIBE `$esTable`";
	$tableA = mod_Query2Array($query, $sql);

	foreach ($tableA as $field)
	{
		if ($field['Field'] == 'id')
		{
			if ($field['Type'] != 'int(11)' || $field['Key'] != 'PRI' || $field['Extra'] != 'auto_increment')
			{
				trigger_error('Invalid ID field in SQL Database: ' . $tablename . ': ' . mprintr($field, true), E_USER_ERROR);
			}
			$idok = true;
		}
		else if (array_key_exists($field['Field'], $table))
		{
			$ref = $table[$field['Field']];
			if (mod_checkTableReplace($field['Type']) != mod_checkTableReplace($ref['type']))
			{
				trigger_error("Invalid Type $field[Type] in Field $field[Field] in Table $tablename, should be $ref[type]", E_USER_ERROR);
			}
			if (count($ref['index']) && $field['Key'] == '')
			{
				$index = implode(',', $ref['index']);
				$query = "ALTER TABLE `$esTable` ADD INDEX ($index)";
				mod_mysql_querya($query, $sql);
			}
			unset($table[$field['Field']]);
		}
	}

	if (!isset($idok))
	{
		trigger_error('Missing ID Field in SQL Database', E_USER_ERROR);
	}

	if (count($table))
	{
		$query = "ALTER TABLE `$esTable` ";
		$adds = $indexes = array();
		foreach ($table as $index => $field)
		{
			$esIndex = mysql_escape_string($index);
			$adds[] = "ADD `$esIndex` $field[type] " . (isset($field['null']) && $field['null'] ? '' : 'NOT ') . "NULL" . (isset($field['default']) ? (' DEFAULT "' . mysql_escape_string($field['default']) . '"') : '');
			if (count($field['index']))
			{
				$indexes[] = "ADD INDEX (" . implode(',', $field['index']) . ")";
			}
		}
		$query .= implode(',', array_merge($adds, $indexes));
		mod_mysql_querya($query, $sql);
	}
}

function mod_array2where($defaults)
{
	$where = array();
	foreach ($defaults as $index => $val)
	{
		$where[] = '`' . mysql_escape_string($index) . '` = "' . mysql_escape_string($val) . '"';
	}
	$where = count($where) ? ('WHERE ' . implode(' AND ', $where)) : '';
	return($where);
}

function mod_storeArrayInTable($sql, $table, $array, $defaults)
{
	$where = mod_array2where($defaults);
	$esTable = mysql_escape_string($table);
	$query = "DELETE FROM `$esTable` $where";
	mod_mysql_querya($query, $sql);

	foreach ($array as $index => $val)
	{
		$query = $defaults;
		$query['name'] = $index;
		$query['value'] = ($query['array'] = intval(!(is_string($val) || is_int($val)))) ? serialize($val) : $val;
		$query = "INSERT INTO `$esTable` (" . implode(',', mod_EscapeArray(array_keys($query), '`', 'mysql_escape_string')) . ') VALUES (' . implode(',', mod_EscapeArray($query, '"', 'mysql_escape_string')) . ')';
		mod_mysql_querya($query, $sql);
	}
}

function mod_retrieveArrayFromTable($sql, $table, $defaults)
{
	$query = "SELECT * FROM `" . mysql_escape_string($table) . '` ' . mod_array2where($defaults);
	$result = mod_mysql_querya($query, $sql);
	$retval = array();
	while ($tmp = mysql_fetch_assoc($result))
	{
		$retval[$tmp['name']] = $tmp['array'] ? unserialize($tmp['value']) : $tmp['value'];
	}
	return($retval);
}

?>
