<?php

require_once 'mod_java.php';

class duallist
{
	public $data = array('', '');			//Takes an array with 2 Elements, one for each list.
							//Each Element may be an array (value => text), a sql query or just a text that is inserted into <select> if it doesnt start with "SELECT"
	public $sql = false;				//SQL Connection
	public $inputname = '';				//Name of Input field
	public $default = '';				//Default Value for Input field
	public $desc = false;				//Array with Captions for both lists.
	public $fullids = false;			//Create Multiple Hidden Inputs for every id instead of xor-ing them
	public $singlelist = false;			//Use Single Select as List with mutliselect then (implies Fullids)
	public $size = false;				//Number of Rows
	public $style = '';				//Style Parameter
}

$mod_dwDualListInstance = 0;
function CreateFormDualList($data)
{
	global $mod_dwDualListInstance, $mod_txt;

	mod_doDefaults($data);

	if (!$data->fullids && $data->default == '') $data->default = 0;

	if ($data->desc === false)
	{
		$data->desc = array('', '');
	}
	else
	{
		$data->desc[0] .= ':<br>';
		$data->desc[1] .= ':<br>';
	}
	$desc = $data->desc;

	$count = 0;

	for($i = 0;$i < 2;$i++)
	{
		if (is_string($data->data[$i]) && stripos($data->data[$i], 'SELECT') === 0)
		{
			$result = mysql_query($data->data[$i], $data->sql);
			$data->data[$i] = array();
			while ($tmp = mysql_fetch_row($result))
			{
				$data->data[$i][$tmp[0]] = $tmp[1];
			}
			mysql_free_result($result);
		}
		if (is_array($data->data[$i]))
		{
			$count += count($data->data[$i]);
			foreach($data->data[$i] as $index => $val)
			{
				$data->data[$i][$index] = '<option value="' . htmlspecialchars($index, ENT_QUOTES) . '">' . htmlspecialchars($val, ENT_QUOTES) . '</option>';
			}
			$data->data[$i] = implode('', $data->data[$i]);
		}
		else
		{
			$count += substr_count($data->data[$i], '<option value=');
		}
	}
	$opt = $data->data;


	$size = max(2, min(10, $data->size === false ? $count : $data->size));

	if ($data->singlelist)
	{
		$retVal = "<select id='mod_singlelist$mod_dwDualListInstance' " . ($data->singlelist !== 2 ? "multiple size=$size" : '') . " style='width:100%;$data->style;' name='$data->inputname[]'>" . str_ireplace('<option ', '<option selected ', $data->data[1]) . $data->data[0] . '</select>';
		if ($data->singlelist !== true)
		{
			$retVal .= "<input id='mod_singlelistbox$mod_dwDualListInstance' " . ($data->singlelist !== 2 ? 'checked' : '') . " type='checkbox' onClick='mod_sl_change($mod_dwDualListInstance, $size, this);'> $mod_txt[form_multiselect]";
		}
	}
	else
	{
		$retVal = "<script>mod_dlinputnames[$mod_dwDualListInstance] = '" . AddSlashes($data->inputname) . "';mod_dlfullids[$mod_dwDualListInstance] = " . intval($data->fullids) . ";</script>";
		if ($data->fullids)
		{
			$retVal .= "<div style='display:none;' id='$data->inputname'></div>";
		}
		else
		{
			$retVal .= "<input type=hidden name='$data->inputname' value='$data->default'>";
		}

		$retVal .= "	<table width=100%><tr>
				<td width=40%>$desc[0]<select style='width:100%;$data->style;' name='mod_dl_opt_1$mod_dwDualListInstance' size=$size onDblClick='mod_dl_add($mod_dwDualListInstance);'>
				$opt[0]
				</select></td>
				<td><input style='width:100%;$data->style;' type=button onClick='mod_dl_add($mod_dwDualListInstance);' value='$mod_txt[form_list_add]'><br>
				<input style='width:100%;'type=button onClick='mod_dl_del($mod_dwDualListInstance);' value='$mod_txt[form_list_rem]'></td>
				<td width=40%>$desc[1]<select style='width:100%;' name='mod_dl_opt_2$mod_dwDualListInstance' size=$size onDblClick='mod_dl_del($mod_dwDualListInstance);'>
				$opt[1]
				</select></td></table>";

		if ($data->fullids)
		{
			$retVal .= "<script>mod_dl_update($mod_dwDualListInstance);</script>";
		}
	}
	$mod_dwDualListInstance++;

	return($retVal);
}

class javasearch
{
	public $data;				//Array with values or SQL Query to get values
	public $sql = false;			//SQL Connection
	public $size = 20;			//Input Field Size
}

$mod_dwJavaSearchInstance = 0;

function CreateJavaSearch(&$data)
{
	global $mod_dwJavaSearchInstance;

	if (is_string($data->data))
	{
		$data->data = mod_Query2Array($data->data, $data->sql, 0);
	}

	$out = "<input type=text size=$data->size onKeyUp='mod_JavaSearchUpdate($mod_dwJavaSearchInstance, this.value);'>";

	$out .= "<table id='mod_javasearch$mod_dwJavaSearchInstance'><tr style='display:none'><td>" . implode('</td></tr><tr style="display:none"><td>', $data->data) . '</td></tr></table>';
	
	$out .= "<script>mod_javasearchdata[$mod_dwJavaSearchInstance] = [" . implode(',', mod_EscapeArray($data->data)) . '];</script>';

	$mod_dwJavaSearchInstance++;
	return($out);
}

class multitext
{
	public $data = array();		//Default data, may be sql query
	public $datasql = false;	//If $data is a string $datasql is passed to mod_Query2Array as Second Parameter, leave false for custom htmlinput with multiple entries, use [NAME][$num] for corresponding cols in mysql_fetch_row
	public $name = 'Text';		//Name of stuff
	public $input = '';		//Name of Input Field
	public $inputhtml = '<input type="text" name="[NAME]">';	//HTML Source for Fields, name as Placeholder, user [NAME][$num] for multilink (sqledit)
	public $selectvals = array();	//When supplying default data, enter numbers of select boxes where 'selected' must be set, set to 1 for single select box!
					//Input Field name=... must be quoted with double quotes and be of form name="[NAME]"!!!
	public $seperator = '';		//
	public $copybutton = false;	//...............
	public $sql = false;
}

$mod_dwMultiTextCount = 0;
function CreateMultiText($data)
{
	global $mod_dwMultiTextCount, $mod_txt;
	if (!is_array($data->data))
	{
		$data->data = mod_Query2Array($data->data, $data->sql, $data->datasql);
	}
	$ret = "<div id='multitext$mod_dwMultiTextCount'>";
	$i = 0;
	foreach ($data->data as $val)
	{
		$ret .= "<div>";
		if (is_array($val))
		{
			$j = 0;
			$tmp = $data->inputhtml;
			while (strpos($data->inputhtml, "[NAME][$j]") !== false)
			{
				if (in_array($j, $data->selectvals))
				{
					$tmp = str_replace(array("<option value=\"" . htmlspecialchars($val[$j]) . "\">", "[NAME][$j]"),
						array("<option value=\"" . htmlspecialchars($val[$j]) . "\" selected>", $data->input . "[$i][$j]"),
						$tmp);
				}
				else
				{
					$tmp = str_replace(array("name=\"[NAME][$j]", "name='[NAME][$j]"),
						array("value='" . htmlspecialchars($val[$j], ENT_QUOTES) . "' name=\"$data->input" . "[$i][$j]", "name='$data->input" . "[$i][$j]"),
						$tmp);
				}
				$j++;
			}

			$ret .= $tmp;
		}
		else
		{
			if ($data->selectvals === 1)
			{
				$ret .= str_replace(array("<option value=\"" . htmlspecialchars($val) . "\">", '[NAME]'),
					array("<option value=\"" . htmlspecialchars($val) . "\" selected>", $data->input . "[$i]"),
					$data->inputhtml);
			}
			else
			{
				$ret .= str_replace('[NAME]"',
					$data->input . "[$i]\" value='" . htmlspecialchars($val, ENT_QUOTES) . "'",
					$data->inputhtml);
			}
		}
		$ret .= " <input type='button' value='" . htmlspecialchars($mod_txt['form_list_rem']) . "' onClick='DeleteMultiText(this);'>";
		if ($data->copybutton)
		{
			$ret .= " <input type='button' value='" . htmlspecialchars($mod_txt['form_list_copy']) . "' onClick='mod_CopyMultiText($mod_dwMultiTextCount, this);'>";
		}
		$ret .= "$data->seperator</div>";
		$i++;
	}
	$ret .= "</div>
		<script>
			mod_multitextinputs[$mod_dwMultiTextCount] = '" . AddSlashes(str_replace(array("\r", "\n"), array(), $data->input)) . "';
			mod_multitextnum[$mod_dwMultiTextCount] = " . count($data->data) . ";
			mod_multitexthtml[$mod_dwMultiTextCount] = '" . AddSlashes(str_replace(array("\r", "\n"), array(), $data->inputhtml)) . "';
			mod_multitextcopy[$mod_dwMultiTextCount] = " . intval($data->copybutton) . ";
			mod_multitextseperators[$mod_dwMultiTextCount] = '" . AddSlashes(str_replace(array("\r", "\n"), array(), $data->seperator)) . "';
		</script>
		<input type='button' value='" . sprintf($mod_txt['form_text_add'], $data->name) . "' onClick='AddMultiText($mod_dwMultiTextCount);'>";

	$mod_dwMultiTextCount++;
	return($ret);
}

class htmledit
{
	public $toolbarclass = 'mod_toolbar';			//Style Sheet Class for Toolbar
	public $htmleditclass = 'mod_htmledit';			//Style sheed for edit field
	public $height = 300;					//Edit Window Height
	public $width = 500;					//Edit Window Width
	public $text = '';					//Text to insert at beginning
	public $inputname = '';					//Name of textarea tag
	public $imgbase = 'http://';				//Base path for image insertion
}

function CreateHtmlEditToolbar($data)
{
	global $modules_defaults, $mod_txt;
	$buttons = array('Undo' => 'undo', 'Redo' => 'redo', 'Insert Link' => 'createlink', 'Insert Image' => 'createimage',
		'Insert Table' => 'createtable', 'Bold' => 'bold', 'Italic' => 'italic', 'Underline' => 'underline',
		'Text Color' => 'forecolor', 'Background Color' => 'hilitecolor', 'Align Left' => 'justifyleft',
		'Center' => 'justifycenter', 'Align Right' => 'justifyright', 'Ordered List' => 'insertorderedlist',
		'Unordered List' => 'insertunorderedlist', 'Outdent' => 'outdent', 'Indent' => 'indent');
	$out = "<table class='$data->toolbarclass' id='mod_toolbar'><tr>
		<td>
			<select id='fontname' onchange='mod_Select(this.id);'>
				<option value='Font'>Font</option>
				<option value='Arial'>Arial</option>
				<option value='Courier'>Courier</option>
				<option value='Times New Roman'>Times New Roman</option>
				<option value='Verdana'>Verdana</option>
				<option value='Tahoma'>Tahoma</option>
				<option value='Trebuchet MS'>Trebuchet MS</option>
			</select>
		</td><td>
			<select unselectable='on' id='fontsize' onchange='mod_Select(this.id);'>
				<option value='Size'>Size</option>
				<option value='1'>1</option>
				<option value='2'>2</option>
				<option value='3'>3</option>
				<option value='4'>4</option>
				<option value='5'>5</option>
				<option value='6'>6</option>
				<option value='7'>7</option>  
			</select>
		</td>";
	foreach ($buttons as $name => $id)
	{
		$out .= "<td><div class='mod_imagebutton' id='mod_$id'>
			<img class='mod_image' src='$modules_defaults[modules_dir]img/$id.gif' alt='" . $mod_txt['html_' . $id] . "' onMouseOver='mod_tbmouseover(this);' onMouseOut='mod_tbmouseout(this);' onMouseDown='mod_tbmousedown(this);' onMouseUp='mod_tbmouseup(this);' onClick='mod_tbclick(this);'></div></td>";
	}
	$out .= "</tr></table>
		<iframe style='visibility:hidden;position:absolute;' width='250' height='170' id='mod_colorpalette' src='$modules_defaults[modules_dir]mod_colors.html'></iframe>
		<script>
			if (document.addEventListener)
			{
				document.addEventListener('mousedown', mod_dismisscolorpalette, true);
				document.addEventListener('keypress', mod_dismisscolorpalette, true);
			}
			else if
			(document.attachEvent)
			{
				document.attachEvent('mousedown', mod_dismisscolorpalette, true);
				document.attachEvent('keypress', mod_dismisscolorpalette, true);
			}
		</script>";

	return($out);
}

$mod_dwHtmlEditInstance = 0;
function CreateHtmlEdit($data)
{
	global $mod_dwHtmlEditInstance, $modules_defaults, $mod_txt, $modules_onevents, $modules_config;

	if ($mod_dwHtmlEditInstance == 0)
	{
		//$modules_onevents['onkeypress'][] = 'mod_htmlediteventb';
		//$modules_onevents['onmouseup'][] = 'mod_htmlediteventb';
		//$modules_onevents['onmousedown'][] = 'mod_htmlediteventb';
	}

	$out = "	<iframe class='$data->htmleditclass' src='" . (isset($modules_config['htmledit_file']) ? $modules_config['htmledit_file'] : "modules/mod_htmledit.php") . "?id=$mod_dwHtmlEditInstance' id='mod_htmledit$mod_dwHtmlEditInstance' width='$data->width' height='$data->height'></iframe>
			<textarea class='$data->htmleditclass' id='mod_htmledittext$mod_dwHtmlEditInstance' name='$data->inputname' style='width:$data->width;height:$data->height;display:none;'></textarea>
			<script>mod_htmledittext[$mod_dwHtmlEditInstance] = '" . str_replace(array("\n", "\r"), array("\\n", ''), AddSlashes($data->text)) . "';mod_htmledittype[$mod_dwHtmlEditInstance] = 0;mod_htmleditimgbase[$mod_dwHtmlEditInstance] = '" . AddSlashes($data->imgbase) . "';</script>
			<input type='checkbox' onClick='mod_changehtmledit($mod_dwHtmlEditInstance, this);' checked> " . $mod_txt['form_html_view'];
	$mod_dwHtmlEditInstance++;
	return($out);
}

class selectparam
{
	public $name = false;				//Name for HTTP GET var
	public $data = array();				//Array with values (Value => name) or sql query with 2 selects
	public $default = false;			//Default value if no HTTP Var found
	public $type = 'select';			//Type (select, text, checkbox)
	public $adddefault = false;			//Add to defaultlink
	public $addlink = '';				//String to add to defaultlink
	public $html = false;				//HTML Format, string to preceed string and append carriage return, array for custom append, false for nothing
	public $defaultlink = false;			//...
}

$mod_dwSelectParamInstance = 0;
function CreateSelectParam(&$data)
{
	global $modules_defaults, $mod_txt, $mod_dwSelectParamInstance;

	mod_doDefaults($data);

	if ($data->html === false) $data->html = array('', '');
	else if (is_string($data->html)) $data->html = array($data->html, '<br>');

	if ($data->name === false)
	{
		$data->name = 'mod_selectparam_' . $mod_dwSelectParamInstance;
		$mod_dwSelectParamInstance++;
	}

	if ($data->adddefault) mod_addDefaultLink($data->name);

	if ($data->type == 'select' && is_string($data->data))
	{
		$result = mod_mysql_querya($data->data);
		$data->data = array();
		while ($tmp = mysql_fetch_row($result))
		{
			$data->data[$tmp[0]] = $tmp[1];
		}
		mysql_free_result($result);
	}

	if (isset($_REQUEST[$data->name]))
	{
		if ($data->type == 'checkbox')
		{
			$data->default = $_REQUEST[$data->name] ? 'checked' : '';
		}
		else
		{
			if ($data->type == 'select' && !isset($data->data[$_REQUEST[$data->name]]))
			{
				$data->default = false;
			}
			else
			{
				$data->default = $_REQUEST[$data->name];
			}
		}
		if ($data->default !== false) $data->addlink = "&$data->name=" . $_REQUEST[$data->name];
	}

	if ($data->default === false)
	{
		if ($data->type == 'select' && is_array($data->data) && count($data->data))
		{
			$tmp = array_keys($data->data);
			$data->default = reset($tmp);

		}
		else if ($data->data != '')
		{
			$data->default = '';
		}
		else
		{
			$data->default = "";
		}
	}

	if ($data->type == 'select')
	{
		$out = "<select name='$data->name' onClick='if (this.value != \"" . htmlspecialchars(AddSlashes($data->default)) . "\") {document.location.href = \"" . htmlspecialchars(AddSlashes(mod_linkAddParameter($data->defaultlink, $data->name, false))) . "&$data->name=\" + this.value;}'>";
		foreach($data->data as $value => $name)
		{
			$out .= "<option value='" . htmlspecialchars($value) . "'" . ($data->default !== false && $value == $data->default ? ' selected' : '') . ">" . htmlspecialchars($name) . "</option>";
		}
		$out .= "</select>";
	}
	else if ($data->type == 'text')
	{
		$out = mod_linkToForm(mod_linkAddParameter($data->defaultlink, $data->name, false), '', 'GET') . "<input type='text' name='$data->name' value='$data->default'> <input type='submit' value='$mod_txt[form_param_send]'></form>";
	}
	else if ($data->type == 'checkbox')
	{
		if (!is_string($data->default) && $data->default) $data->default = 'checked';
		$out = "<input $data->default type='checkbox' name='$data->name' onClick='document.location.href = \"" . htmlspecialchars(AddSlashes(mod_linkAddParameter($data->defaultlink, $data->name, false))) . "&$data->name=\" + (this.checked ? 1 : 0);'>";
	}
	return($data->html[0] . $out . $data->html[1]);
}

function mod_param_configarray(&$array, $paramarray, $dotable = true)
{
	$retval = array();
	if ($dotable !== false) echo '<table ', $dotable === true ? '' : $dotable, '>';
	foreach ($paramarray as $index => $param)
	{
		$selectparam = new selectparam;
		mod_doDefaults($selectparam, $param, true);
		if (isset($array[$index])) $selectparam->default = $array[$index];
		$oldval = $selectparam->default;
		if ($dotable !== false) $selectparam->html = array("<tr><td>$selectparam->html</td><td>", '</td></tr>');
		echo CreateSelectParam($selectparam);
		if ($selectparam->type == 'checkbox')
		{
			$selectparam->default = ($selectparam->default !== '');
		}
		if ($selectparam->default !== $oldval)
		{
			$array[$index] = $selectparam->default;
			$retval[] = $selectparam->name;
		}
	}
	if ($dotable !== false) echo '</table>';
	return($retval);
}

class usertable
{
	public $data = false;		//Data to use (If no 2-dimensional array supply 2 entries for rows/cols or nothing for no table before rezize button is pressed!
	public $input = '';		//Name of Input Fields
	public $fixed = false;		//Fixed Size?
	public $titles = false;		//Titles (array(rowtitles => array(...), coltitles => array(...)) though numeric not 'rowtitles' (= 0), simply true for editable titles
	public $styles = array('', '');	//Style clauses, titles, standard fields
}

$mod_dwUserTableInstance = 0;
function CreateUserTable($data)
{
	global $mod_dwUserTableInstance, $mod_txt;

	$ret = "<div id='mod_usertable$mod_dwUserTableInstance'></div><script>";

	if (is_array($data->data))
	{
		if (count($data->data) == 0)
		{
			$data->data = false;
		}
		else if (is_array($data->data[0]))
		{
			$rows = count($data->data);
			$cols = count($data->data[0]);
		}
		else
		{
			$rows = $data->data[0];
			$cols = $data->data[1];
			$empty = true;
		}
	}

	$ret .= "mod_usertabledata[$mod_dwUserTableInstance] = [";
	if ($data->data !== false)
	{
		$tmp = array();
		for ($i = 0;$i < $rows;$i++)
		{
			$tmp[$i] = array();
			for ($j = 0;$j < $cols;$j++)
			{
				$tmp[$i][$j] = '"' . (isset($empty) ? '' : AddSlashes(htmlspecialchars($data->data[$i][$j]))) . '"';
			}
			$tmp[$i] = '[' . implode(',', $tmp[$i]) . ']';
		}

		$ret .= implode(',', $tmp);
	}
	else
		$rows = $cols = 0;

	$ret .= "];\nmod_usertablenames[$mod_dwUserTableInstance] = '" . AddSlashes($data->input) . "';\n";
	$ret .= "mod_usertablestyles[$mod_dwUserTableInstance] = [" . implode(',', mod_EscapeArray($data->styles, "'", 'AddSlashes')) . "];\n";

	$edittitles = 0;
	if ($data->titles === true)
	{
		$edittitles = 1;
		if ($rows) $rows--;
		if ($cols) $cols--;
	}
	else if (is_array($data->titles))
	{
		$data->titles = mod_EscapeArray($data->titles);
		$ret .= "mod_usertablerowtitles[$mod_dwUserTableInstance] = [" . implode(',', $data->titles[0]) . "];
				mod_usertablecoltitles[$mod_dwUserTableInstance] = [" . implode(',', $data->titles[1]) . "];\n";
	}
	$ret .= "mod_usertableedittitles[$mod_dwUserTableInstance] = $edittitles;\n";
	$ret .= "mod_usertablefixed[$mod_dwUserTableInstance] = " . intval($data->fixed) . ";\n";

	$ret .= "mod_CreateUserTable($mod_dwUserTableInstance);</script>";

	if (!$data->fixed) $ret .= $mod_txt['form_rows'] . ": <input type=text value='$rows' id='mod_usertable_rows_$mod_dwUserTableInstance' size=3> -
		$mod_txt[form_cols]: <input type=text value='$cols' id='mod_usertable_cols_$mod_dwUserTableInstance' size=3>
		<input type=button value='$mod_txt[form_resize]' onClick='mod_usertable_resize($mod_dwUserTableInstance);'>";

	$mod_dwUserTableInstance++;
	return($ret);
}

class displaydirectory
{
	public $sql = false;				//SQL Connection
	public $table = false;				//SQL Table Name
	public $callback_function = false;		//Callback Function, that is called to produce output ($id, $name) where $name is the namefield's text. Give that back to override it
	public $defaultlink;
	public $root = -1;				//Root to start display from
	public $changeroot = true;			//Allow to enter Directories, may enter array('sql field' => 'forced val'), field is not escaped!!
	public $indent = 0;				//Indent to start with
	public $indenttxt = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';	//Indent Text, give an integer to indent with margin style where the value is the pixel count
	public $name = 'name';				//Name Field
	public $dirname = 'Name';			//Table caption for name
	public $sort = 'sort';				//Name of field with sort entry, false for no sort, array for user definet sort in a string
	public $addlink = '';				//A Link parameter is returned, that must be appended to links to preserve the directory
	public $sqlwhere = false;			//user defined where clause
	public $tabledata = array();			//Will be passed to sorttable
	public $edit = false;				//SQLEdit Object to edit directory
	public $savedelete = false;			//...
	public $keeplines = true;			//Dont insert brs
	public $sqljoin = '';				//Join..
	public $html = false;				//Html Code where [NAME] must be a placeholder that will be replaced with line name
	public $rootname = 'Root';			//Name for prelines
	public $expandall = false;			//Expand whole dir
}

function mod_CreateDirectory_doLink($id, &$sign)
{
	global $mod_dwDirectoryInstance, $modules_defaults;

	if (!isset($_REQUEST["mod_diropened$mod_dwDirectoryInstance"]))
	{
		$sign = 0;
		$link = $id;
	}
	else
	{
		$links = explode(',', $_REQUEST["mod_diropened$mod_dwDirectoryInstance"]);
		if (in_array($id, $links))
		{
			$sign = 1;
			$link = implode(',', mod_array_filter_elem($links, $id));
		}
		else
		{
			$sign = 0;
			$link = $_REQUEST["mod_diropened$mod_dwDirectoryInstance"] . ",$id";
		}
	}
	if ($sign) $sign = 'minus';
	else $sign = 'plus';

	$sign = "<img border=0 src='$modules_defaults[modules_dir]img/$sign.gif'>";

	return($link);
}

$mod_dwDirectoryInstance = 0;
function mod_CreateDirectory_doLine($data, $indent, $root, $esName, $esTable, $esSort, &$table)
{
	global $mod_dwDirectoryInstance, $mod_dirsubedit, $mod_txt;
	$select = array("`$esName`", 'id');
	if ($esSort !== false)
	{
		$order = " ORDER BY $esSort";
	}
	else
	{
		$order = '';
	}
	if (is_array($data->changeroot)) $select = array_merge($select, array_keys($data->changeroot));
	$query = 'SELECT ' . implode(',', $select) . " FROM `$esTable` $data->sqljoin WHERE root = $root " . ($data->sqlwhere === false ? '' : ' AND ' . $data->sqlwhere) . ($data->savedelete ? ' AND deleted = 0' : '') . " $order";
	$result = mod_mysql_querya($query, $data->sql);
	while ($tmp = mysql_fetch_assoc($result))
	{
		$query = "SELECT COUNT(*) FROM `$esTable` WHERE root = $tmp[id]" . ($data->sqlwhere === false ? '' : ' AND ' . $data->sqlwhere);
		$name = $data->keeplines ? str_replace(' ', '&nbsp;', $tmp[$data->name]) : $tmp[$data->name];
		if ($linkpresent = mysql_result(mod_mysql_querya($query, $data->sql), 0))
		{
			$sign = '';
			if ($data->expandall) $link = ''; else
			$link = "<a href='$data->defaultlink&mod_diropened$mod_dwDirectoryInstance=" . mod_CreateDirectory_doLink($tmp['id'], $sign) . "#mod_dir_$mod_dwDirectoryInstance-$tmp[id]'>$sign</a>&nbsp;&nbsp;";
		}
		else
		{
			$link = '';
		}

		if ($data->changeroot !== false)
		{
			if (($tmproot = $linkpresent) || is_array($data->changeroot))
			{
				$tmproot = true;
				if (is_array($data->changeroot))
				{
					foreach ($data->changeroot as $tmpind => $tmpval)
					{
						if ($tmp[$tmpind] != $tmpval)
						{
							$tmproot = false;
							break;
						}
					}
				}
			}
			if ($tmproot) $name = "<a href='$data->defaultlink$data->addlink&mod_dirsetroot$mod_dwDirectoryInstance=$tmp[id]'>$name</a>";
		}

		$name = "<a name='mod_dir_$mod_dwDirectoryInstance-$tmp[id]'></a>" . (is_string($data->indenttxt) ? str_repeat($data->indenttxt, $indent) : ("<div style='padding-left:" . ($data->indenttxt * $indent + ($link == '' ? 15 : 0)) . "px;'>")) . ($data->html === false ? "$link$name" : str_replace('[NAME]', $link . $name, $data->html)) . (is_string($data->indenttxt) || $data->html !== false ? '' : '</div>');
		$retVal = call_user_func($data->callback_function, $tmp['id'], $name, $data);
		if ($retVal !== false)
		{
			$table[] = array_merge(array($data->dirname => $name), $retVal, $data->edit !== false ? array($mod_txt['form_dir_edit'] => $mod_dirsubedit[$tmp['id']]) : array());
			if ($data->expandall || (isset($_REQUEST["mod_diropened$mod_dwDirectoryInstance"]) && in_array($tmp['id'], explode(',', $_REQUEST["mod_diropened$mod_dwDirectoryInstance"]))))
			{
				mod_CreateDirectory_doLine($data, $indent + 1, $tmp['id'], $esName, $esTable, $esSort, $table);
			}
		}
	}
}

function CreateDirectory($data)
{
	global $mod_dwDirectoryInstance, $mod_dirsubedit;
	mod_doDefaults($data);

	$data->addlink = "&mod_diropened$mod_dwDirectoryInstance=" . (isset($_REQUEST["mod_diropened$mod_dwDirectoryInstance"]) ? $_REQUEST["mod_diropened$mod_dwDirectoryInstance"] : '');
	if ($data->changeroot !== false)
	{
		if (isset($_REQUEST["mod_dirsetroot$mod_dwDirectoryInstance"])) $_REQUEST["mod_dirroot$mod_dwDirectoryInstance"] = $_REQUEST["mod_dirsetroot$mod_dwDirectoryInstance"];
		if (!isset($_REQUEST["mod_dirroot$mod_dwDirectoryInstance"]) || !mod_checkTableId($data->table, $_REQUEST["mod_dirroot$mod_dwDirectoryInstance"] = intval($_REQUEST["mod_dirroot$mod_dwDirectoryInstance"])))
		{
			$_REQUEST["mod_dirroot$mod_dwDirectoryInstance"] = $data->root;
		}
		$data->addlink .= "&mod_dirroot$mod_dwDirectoryInstance=" . $_REQUEST["mod_dirroot$mod_dwDirectoryInstance"];
		$data->defaultlink .= "&mod_dirroot$mod_dwDirectoryInstance=" . $_REQUEST["mod_dirroot$mod_dwDirectoryInstance"];
	}

	$esName = mysql_escape_string($data->name);
	$esTable = mysql_escape_string($data->table);
	$esSort = is_array($data->sort) ? $data->sort[0] : ($data->sort === false ? false : ('`' . mysql_escape_string($data->sort) . '`'));

	if ($data->edit !== false)
	{
		$data->edit->sqltablename = $data->table;
		$data->edit->subedit = true;
		$data->edit->defaultlink = $data->defaultlink . $data->addlink;
		$data->edit->sqlsortwhere[] = 'root';
		$data->edit->savedelete = $data->savedelete;
		if ($data->edit->sqlforcewhere === false) $data->edit->sqlforcewhere = $data->sqlwhere;
		else $data->edit->sqlforcewhere .= ' AND ' . $data->sqlwhere;

		if ($data->changeroot !== false && isset($data->edit->relations['root']))
		{
			if (!isset($data->edit->relations['root']['default'])) $data->edit->relations['root']['default'] = $_REQUEST["mod_dirroot$mod_dwDirectoryInstance"];
			if (!isset($data->edit->relations['root']['rootname'])) $data->edit->relations['root']['rootname'] = $data->rootname;
		}
		$mod_dirsubedit = CreateSqlEdit($data->edit);
	}

	if ($data->savedelete)
	{
		if ($data->sqlwhere === false) $data->sqlwhere = "`$esTable`.deleted = 0";
		else $data->sqlwhere = "($data->sqlwhere) AND `$esTable`.deleted = 0";
	}

	$table = new table;
	$table->data = array();
	mod_CreateDirectory_doLine($data, $data->indent, $data->changeroot !== false ? $_REQUEST["mod_dirroot$mod_dwDirectoryInstance"] : $data->root, $esName, $esTable, $esSort, $table->data);
	mod_doDefaults($table, $data->tabledata, true);
	$table->sortable = false;
	$table->width = '100%';
	$table->inTd = 'valign=top';
	if ($data->changeroot !== false && $_REQUEST["mod_dirroot$mod_dwDirectoryInstance"] != $data->root)
	{
		$table->data = array(mod_AdeptPreLines(mod_CreatePrelines("mod_dirsetroot$mod_dwDirectoryInstance", $_REQUEST["mod_dirroot$mod_dwDirectoryInstance"], $data->table, $data->rootname, $data->sql, $data->dirname), count($table->data) ? array_keys($table->data[0]) : array($data->dirname)), $table->data);
		$table->multi_data = true;
	}
	echo CreateTable($table);

	if ($data->edit !== false)
	{
		echo $mod_dirsubedit['edit'];
	}

	$mod_dwDirectoryInstance++;
}

class multiview
{
	public $data = array();				//Data $name => $data
	public $type = 0;				//0: Send all Data in HTML File ans change with JavaScript, 1: Send only one data part and change with php, -1: Same as 1 but but array contains array('callbackfunc', 'param')
	public $default = false;			//Name for default data, false for first
	public $defaultlink = false;
}
$mod_dwMultiviewInstance = 0;

function CreateMultiView($data)
{
	global $mod_dwMultiviewInstance;
	mod_doDefaults($data);

	if (count($data->data) == 0) return;
	if (count($data->data) == 1)
	{
		echo reset($data->data);
		return;
	}

	$selectpart = $datapart = array();
	$i = 0;
	if ($data->type != 0 && isset($_REQUEST["mod_multiview$mod_dwMultiviewInstance"]) && ($default = intval($_REQUEST["mod_multiview$mod_dwMultiviewInstance"])) <= count($data->data)) $data->default = mod_ae2(array_keys($data->data), $default);
	else if ($data->default !== false && !isset($data->data[$data->default])) $data->default = false;
	foreach ($data->data as $index => $val)
	{
		$use = (($data->default === false && $i == 0) || ($data->default !== false && $index == $data->default));
		$index = mod_nbsp($index);
		$selectpart[] = ($data->type != 0 && $use ? "<b>$index</b>" : ("<a " . ($data->type == 0 && $use ? "style='font-weight:bold;' " : '') . "id='mod_multiviewbtn$mod_dwMultiviewInstance-$i' href='" . ($data->type == 0 ? "JavaScript:mod_activatemultiview($mod_dwMultiviewInstance, $i);" : "$data->defaultlink&mod_multiview$mod_dwMultiviewInstance=$i") . "'>$index</a>"));
		if ($data->type == 0)
		{
			$datapart[] = "<div id='mod_multiview$mod_dwMultiviewInstance-$i'" . ($use ? '' : ' style="display:none;"') . '>' . $val . '</div>';
			if ($use) echo "<script>mod_multiviewcur[$mod_dwMultiviewInstance] = $i;</script>";
		}
		else if ($use)
		{
			if ($data->type == 1)
			{
				$datapart[] = $val;
			}
			else
			{
				$datapart[] = call_user_func($val[0], $val[1]);
			}
		}
		$i++;
	}

	echo implode(' - ', $selectpart), '<br>', implode('', $datapart);
	$mod_dwMultiviewInstance++;
}

if (!isset($mod_nolayout) || !$mod_nolayout)
{
	echo "<div id='mod_nicealert' style='display:none;' onClick='mod_hideNiceAlert();'></div>";
	$modules_onevents['onkeypress'][] = 'mod_hideNiceAlert';
	$modules_onevents['onmouseup'][] = 'mod_hideNiceAlert';
	$modules_onevents['onmousedown'][] = 'mod_hideNiceAlert';
}


?>