<?php

class restore
{
	public $sql = false;			//SQL Connection
	public $tables = array();		//Array with 'tablename' => array(fieldnames to display), Fields with not numeric indexes have that index displayed as name in the table / Name: 'add_sql' to just add to select part (wont be escaped)
	public $allowrestore = true;		//Allow to restore deleted entries
	public $allowdelete = false;		//Allow to finally delete entries
	public $usertable = false;		//Table with users to display which user deleted an entry
	public $join = '';			//Custom Join
	public $defaultlink = false;		//See somewhere else...
	public $archive = false;		//Add archive button
}

$mod_dwRestoreInstance = 0;
function CreateRestore($data)
{
	global $mod_dwRestoreInstance, $modules_defaults, $mod_txt;
	$dwTableNum = 0;
	mod_doDefaults($data);

	if ($data->usertable !== false)	$esUser = mysql_escape_string($data->usertable);

	if ($data->archive)
	{
		$archive = new selectparam;
		$archive->name = 'mod_archres';
		$archive->type = 'checkbox';
		echo $mod_txt['rest_arch'], CreateSelectParam($archive);

		$data->defaultlink .= mod_addLink('mod_archres');
	}

	foreach ($data->tables as $index => $fields)
	{
		$check = array('deleted' => array('int' => 11, 'index' => 0));
		checkTable($check, $index, $data->sql);
		$esTable = mysql_escape_string($index);

		$select = array();

		$join = $data->join;

		foreach ($fields as $name => $field)
		{
			if ($name == 'add_sql')
			{
				$select[] = $field;
				continue;
			}
			$esName = mysql_escape_string($name);
			$esField = mysql_escape_string($field);

			$select[] = "`$esTable`.`$esField`" . (is_numeric($name) ? '' : " AS '$esName'");
		}
		if ($data->usertable !== false) $select[] = "`mod_restore_$esUser`.username AS 'Deleted By'";

		$operations = array(
			'Restore' => array('var' => 'allowrestore', 'get' => 'mod_resdo'    , 'query' => "UPDATE `[TABLE]` SET deleted = 0 WHERE id = [ID]"),
			'Delete'  => array('var' => 'allowdelete' , 'get' => 'mod_reddelete', 'query' => "DELETE FROM `[TABLE]` WHERE id = [ID]"),
			'Archive' => array('var' => 'archive', 'get' => 'mod_resarch', 'query' => "UPDATE `[TABLE]` SET deleted = - deleted WHERE id = [ID]")
		);
		$functions = array();

		foreach ($operations as $name => $operation)
		{
			if ($data->$operation['var'])
			{
				if (isset($_GET['mod_res']) && $_GET['mod_res'] == $mod_dwRestoreInstance && isset($_GET['mod_restable']) && $_GET['mod_restable'] == $dwTableNum && isset($_GET[$operation['get']]))
				{
					$query = str_replace(array('[TABLE]', '[ID]'), array($esTable, intval($_GET[$operation['get']])), $operation['query']);
					mod_mysql_querya($query, $data->sql);
					if (isset($modules_defaults['mod_redir_changes']) && $modules_defaults['mod_redir_changes'])
					{
						mod_redir_changes(array('mod_res'));
					}
				}
				$functions[] = "CONCAT('<a href=\"" . mysql_escape_string($data->defaultlink) . "&mod_res=$mod_dwRestoreInstance&mod_restable=$dwTableNum&$operation[get]=', `$esTable`.id, '\">$name</a>')";
			}
		}

		if ($data->archive && $archive->default == 'checked')
		{
			$select[] = "IF(`$esTable`.deleted < 0,'" . mysql_escape_string($mod_txt['rest_arch']) . "', '-') AS `" . mysql_escape_string($mod_txt['rest_arch']) . '`';
		}
		if (count($functions)) $select[] = 'CONCAT(' . implode(', ", ", ', $functions) . ') AS Funktionen';

		if ($data->usertable !== false) $join .= " LEFT JOIN `$esUser` AS `mod_restore_$esUser` ON `mod_restore_$esUser`.id = ABS(`$esTable`.deleted)";

		$where = ($data->archive !== true || $archive->default != 'checked') ? "`$esTable`.deleted > 0" : "`$esTable`.deleted != 0";

		$query = 'SELECT ' . implode(',', $select) . " FROM `$esTable` $join WHERE $where";
		CreateTableA(array('data' => $query, 'sql' => $data->sql, 'width' => '90%', 'title' => 'Restoration: ' . $index, 'emptytable' => false));
		echo '<br>';

		$dwTableNum++;
	}
	$mod_dwRestoreInstance++;
}


?>