<?php

class template
{
	public $vars = array();				//Var names
	public $sql = false;				//SQL Connection
	public $sqltablename = false;			//SQL Table Name (id index)
	public $templates = array();			//Array with standard templates (string index)
	public $template = true;			//Template, stirng for $templates, int for table id, true for HTTP Request
	public $defaulttemplate = false;		//Default Template in case of errors.

	public $preparedtemplate = '';			//Tempvar
}

function mod_Template_RecurseAdd($var, $prename, &$vars, &$names)
{
	if (is_array($var))
	{
		foreach ($var as $index => $subvar)
		{
			mod_Template_RecurseAdd($subvar, $prename . '[' . strtoupper($index) . ']', $vars, $names);
		}
	}
	else
	{
		$vars[] = $var;
		$names[] = $prename;
	}
}

function PrepareTemplate(&$data)
{
	global $modules_config, $modules_defaults, $userdata, $mod_nocss;
	mod_doDefaults($data);

	if (isset($modules_config['templates'])) $data->templates = array_merge($modules_config['templates'], $data->templates);

	if ($data->template === true)
	{
		if (isset($modules_defaults['user_data_config']) && isset($userdata['data']['mod_config']['template'])) $data->template = $userdata['data']['mod_config']['template'];
		else $data->template = isset($_REQUEST['mod_template']) ? $_REQUEST['mod_template'] : $data->defaulttemplate;
	}

	for ($i = 0;$i < 2;$i++)
	{
		if (is_numeric($data->template))
		{
			if (!mod_checkTableId($data->sqltablename, $data->sql, $data->template)) $data->template = false;
		}
		else if ($data->template !== false)
		{
			if (!isset($data->templates[$data->template])) $data->template = false;
		}
		if ($i == 0 && $data->template === false) $data->template = $data->defaulttemplate;
	}

	if ($data->sqltablename !== false && is_numeric($data->template))
	{
		$template = mod_getTableNameFromId($data->sqltablename, $data->template, $data->sql, 'template');
	}
	else if (is_string($data->template))
	{
		$template = $data->templates[$data->template];
	}
	else
	{
		$template = false;
	}

	if (is_array($template))
	{
		$modules_config['template'] = $template;

		$template = $template['template'];
	}

	$data->preparedtemplate = $template;
}

function CreateTemplate($data)
{
	$template = $data->preparedtemplate;
	$vars = $names = array();
	foreach ($data->vars as $var)
	{
		global $$var;
		$tmp = $$var;
		mod_Template_RecurseAdd($tmp, '[' . strtoupper($var) . ']', $vars, $names);
	}

	if ($template === false) $template = count($data->templates) ? reset($data->templates) : implode('', $names);
	echo str_replace($names, $vars, $template);
}

class indextable
{
	public $sql;				//SQL Connection
	public $sqltablename;			//SQL Table Name
	public $html = array('', '');		//Html to hang in front and append text output
	public $editdata = array();		//Pass to sqledit
	public $fulledit = true;		//Set false to disable index edit, addable, deleteable
}

function CreateIndexTable($data, $index)
{
	global $mod_use, $menu;

	mod_doDefaults($data);

	$esTable = mysql_escape_string($data->sqltablename);
	$query = "SELECT * FROM `$esTable` WHERE `index` = '" . mysql_escape_string($index) . "'";
	$result = mod_mysql_querya($query, $data->sql);
	if (mysql_num_rows($result))
	{
		$tmp = mysql_fetch_assoc($result);
		echo $data->html[0], $tmp['text'], $data->html[1];

		if ($tmp['caption'] == '' && isset($mod_use) && isset($menu))
		{
			$tmp['caption'] = mod_getMenuName($menu);
		}
		return($tmp['caption']);
	}
	return(false);
}

function CreateIndexEdit($data)
{
	global $mod_txt;
	mod_doDefaults($data);

	$esTable = mysql_escape_string($data->sqltablename);

	$edit = new sqledit;
	$edit->sqltablename = $data->sqltablename;
	$edit->sortable = "`$esTable`.`index` ASC";

	$edit->relations = array(
		'index' => array('name' => 'Index', 'force' => true, 'nodual' => true),
		'caption' => array('name' => $mod_txt['index_caption']),
		'text' => array('name' => 'Text', 'type' => 'html', 'htmltoolbar' => true, 'rows' => 600, 'force' => true, 'hide' => true)
	);

	$edit->name = $mod_txt['index_name'];
	$edit->title = $mod_txt['index_title'];

	if (!$data->fulledit)
	{
		$edit->addable = $edit->deleteable = false;
		$edit->relations['index']['editable'] = false;
	}
	
	mod_doDefaults($edit, $data->editdata, true);
	CreateSqlEdit($edit);
}

?>